import { HttpClient, HttpEvent, HttpHeaders, HttpParams, HttpResponse } from '@angular/common/http';
import { Inject, Injectable, Optional } from '@angular/core';
import { Observable } from 'rxjs';

import { Configuration } from '../configuration';
import { CustomHttpUrlEncodingCodec } from '../encoder';
import { ResponseStats200 } from '../model/responseStats200';
import { BASE_PATH } from '../variables';

/**
 * Tankerkönig API
 * API for getting real time gas prices from https://creativecommons.tankerkoenig.de. Real time gas price data is available under open data/open source license even for commercial use. Currently only prices for Germany are available.
 *
 * OpenAPI spec version: 4.0.6
 * Contact: info@tankerkoenig.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */ /* tslint:disable:no-unused-variable member-ordering */

@Injectable()
export class TankerkoenigStatisticsService {
  protected basePath = 'https://creativecommons.tankerkoenig.de/api/v4';
  public defaultHeaders = new HttpHeaders();
  public configuration = new Configuration();

  constructor(protected httpClient: HttpClient, @Optional() @Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
    if (basePath) {
      this.basePath = basePath;
    }
    if (configuration) {
      this.configuration = configuration;
      this.basePath = basePath || configuration.basePath || this.basePath;
    }
  }

  /**
   *
   *
   * @param apikey Gültiger API-key / Valid API key.
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public statsGet(apikey: string, observe?: 'body', reportProgress?: boolean): Observable<ResponseStats200>;
  public statsGet(apikey: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ResponseStats200>>;
  public statsGet(apikey: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ResponseStats200>>;
  public statsGet(apikey: string, observe: any = 'body', reportProgress: boolean = false): Observable<any> {
    if (apikey === null || apikey === undefined) {
      throw new Error('Required parameter apikey was null or undefined when calling statsGet.');
    }

    let queryParameters = new HttpParams({
      encoder: new CustomHttpUrlEncodingCodec(),
    });
    if (apikey !== undefined && apikey !== null) {
      queryParameters = queryParameters.set('apikey', <any>apikey);
    }

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = ['application/json; charset=utf-8'];
    const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set('Accept', httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header

    return this.httpClient.request<ResponseStats200>('get', `${this.basePath}/stats`, {
      params: queryParameters,
      withCredentials: this.configuration.withCredentials,
      headers: headers,
      observe: observe,
      reportProgress: reportProgress,
    });
  }
}
